=== debian/changelog ===
onednn (2.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Test build in debian/experimental worked, release to unstable.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 31 Dec 2020 09:35:28 +0100

onednn (2.0+ds-2~0exp0simde) experimental; urgency=medium

  * Team upload.
  * Rebuild using SIMDe 0.7.0-1
  * Mark -doc as Multi-Arch: foreign
  * debian/copyright: refresh
  * debian/source/lintian-overrides: unused, removed
  * Standards-Version: 4.5.1 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * debian/upstream/metadata: update URLs
  * documented cmake-no-install-ocl-cmake.patch

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 30 Dec 2020 16:01:54 +0100

onednn (2.0+ds-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sat, 12 Dec 2020 10:07:32 +0800

onednn (2.0+ds-1~exp1) experimental; urgency=medium

  * New upstream version 2.0+ds (Dec. 2020)
  * SOVERSION bump from 1 -> 2 following upstream.
  * Fix typo in Autopkgtest generator and control files.
  * Refresh symbols for amd64.
  * Only track symbols for the amd64 architecture.

 -- Mo Zhou <lumin@debian.org>  Thu, 10 Dec 2020 21:19:18 +0800

onednn (2.0~beta10+ds-2) unstable; urgency=medium

  * Refresh symbols control file for s390x to address FTBFS.
  * Autopkgtest: restrict supported arches to amd64 arm64 ppc64el s390x.

 -- Mo Zhou <lumin@debian.org>  Sun, 22 Nov 2020 15:20:33 +0800

onednn (2.0~beta10+ds-1) unstable; urgency=medium

  * New upstream version 2.0~beta10+ds
  * d/copyright: Also exclude doc/assets/fonts directory.
  * Deprecate patch: html-template-no-privacy-breach.patch
  * Add s390x to supported architecture list as per upstream changelog.
  * Install the newly added headers to the -dev package.
  * Refresh symbols control file for amd64, arm64 and ppc64el.

 -- Mo Zhou <lumin@debian.org>  Tue, 03 Nov 2020 14:21:23 +0800

onednn (2.0~beta8+ds-4) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * debian/patches/simde: enable compilation on non-x86 (Closes: #973370)

  [ Mo Zhou ]
  * Add symbols control file for arm64 and ppc64el.
  * Add Build-Depends-Package field in symbols file.

 -- Mo Zhou <lumin@debian.org>  Sat, 31 Oct 2020 10:32:37 +0800

onednn (2.0~beta8+ds-3) unstable; urgency=medium

  * Breaks & Replaces libmkldnn1 and libmkldnn-dev. (Closes: #972465)
  * Packaging repo has been transferred from science team to deep learning team.
  * Replace the science team with deep learning team in maintainer field.

 -- Mo Zhou <lumin@debian.org>  Mon, 19 Oct 2020 22:01:16 +0800

onednn (2.0~beta8+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 16 Oct 2020 10:39:54 +0800

onednn (2.0~beta8+ds-1) experimental; urgency=medium

  * New upstream version 2.0~beta8+ds
  * Refresh existing patches and symbols control file.
  * Add ppc64el to the list of supported Architectures.
  * Update d/tests/testutil.sh and regenerate autopkgtest control file.

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Sep 2020 12:36:30 +0800

onednn (2.0~beta7+ds-1) experimental; urgency=medium

  * New upstream version 2.0~beta7+ds
  * Rebase cmake-no-install-ocl-cmake.patch.
  * Install the MKLDNN compat cmake files again.
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Tue, 14 Jul 2020 21:52:07 +0800

onednn (2.0~beta6+ds-1~exp1) experimental; urgency=medium

  * New upstream version 2.0~beta6+ds
  * Refresh the patches.
  * Enable arm64 in the Architecture list.
  * Bump debhelper compat level to 13.
  * Create a directory to workaround a install failure.
  * Nolonger create symlinks for the mathjax directory.
  * Install one new header file.
  * Refresh symbols control file.
  * Apply wrap-and-sort.
  * Uscan: add repacksuffix and dversionmangle.

 -- Mo Zhou <lumin@debian.org>  Thu, 04 Jun 2020 16:58:04 +0800

onednn (2.0~beta5-1) experimental; urgency=medium

  * New upstream version 2.0~beta5
  * Source has been renamed to oneDNN by upstream.
  * Rename the source packages and binary packages, and rewrite the short/long
    package descriptions. Rename control files as well.
  * Bump Standards-Version to 4.5.0 (no change).
  * Update upstream homepage, and d/watch using new upstream URL.
  * Add libtbb-dev to B-D.
  * Update upstrean name and source URL in d/copyright.
  * Update the Salsa URL due to repo rename.

 -- Mo Zhou <lumin@debian.org>  Fri, 17 Apr 2020 14:13:22 +0800

mkl-dnn (2.0~beta4-1) unstable; urgency=medium

  * New upstream version 2.0~beta4
  * Deal with the files reported by dh_missing.
  * Refresh symbols control file.
  * Patch CMake to skip installation of FindOpenCL.cmake

 -- Mo Zhou <lumin@debian.org>  Thu, 13 Feb 2020 11:24:45 +0800

mkl-dnn (2.0~beta3-2) unstable; urgency=medium

  * Autopkgtest: depends on ocl-icd-opencl-dev and link against libOpenCL.
  * Let libmkldnn-dev Recommend ocl-icd-opencl-dev. (Closes: #947894)

 -- Mo Zhou <lumin@debian.org>  Fri, 17 Jan 2020 13:34:58 +0800

mkl-dnn (2.0~beta3-1) unstable; urgency=medium

  * New upstream version 2.0~beta3
  * Enable OpenCL (update B-D, flags in rules, symbols).
  * Change dh_missing from list-missing to fail-missing.
  * Symlinks libmkldnn*.so* are no longer provided (SONAME transition).
  * control&copyright: Update my mail address.

 -- Mo Zhou <lumin@debian.org>  Sat, 28 Dec 2019 15:26:17 +0800

mkl-dnn (1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 25 Oct 2019 12:05:58 +0800

mkl-dnn (1.1-3) unstable; urgency=medium

  * Update d/tests/testutil.sh and re-generate autopkgtest control file.
  * Switch buildsystem to cmake+ninja.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 19 Oct 2019 13:59:30 +0800

mkl-dnn (1.1-2) unstable; urgency=medium

  * Nolonger differentiate the arch/indep rules. (Fixes FTBFS on arch:all)

