=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%onednn_$1.orig.tar.gz%, repacksuffix=+ds, dversionmangle=s/\+ds\d*$//" \
	https://github.com/oneapi-src/oneDNN/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
